#!/usr/bin/ruby

require_relative 'dominance'

# Example from Keith D. Cooper, Timothy J. Harvey, Key Kennedy - "A Simple, Fast Dominance Algorithm"
cfg = CFG.new()
node1 = cfg.add_node(CFG::Node.new(1))
node2 = cfg.add_node(CFG::Node.new(2))
node3 = cfg.add_node(CFG::Node.new(3))
node4 = cfg.add_node(CFG::Node.new(4))
node5 = cfg.add_node(CFG::Node.new(5))
node6 = cfg.add_node(CFG::Node.new(6))
cfg.add_edge(node1, node2)
cfg.add_edge(node2, node1)
cfg.add_edge(node4, node1)
cfg.add_edge(node3, node2)
cfg.add_edge(node5, node4)
cfg.add_edge(node5, node3)
cfg.add_edge(node5, node6)
cfg.start = node5

p cfg
p cfg.postorder()
dom, idom = cfg.calculate_dominators()
p dom
p idom
p cfg.calculate_dominance_frontiers()


