#!/usr/bin/ruby

module Working_with_types

  def is_object_type?(t)
    t.is_a?(Array) and (t[0] == :obj_type or t[0] == :forall)
  end

  def is_method_type?(t)
    t.is_a?(Array) and t[0] == :method
  end

  def is_constructor?(t)
    t.is_a?(Array) and t[0] == :constructor
  end

  def class_name(constructor)
    raise RuntimeError.new("invalid constructor type") unless constructor[0] == :constructor
    constructor[1]
  end

  def constructor_params(constructor)
    raise RuntimeError.new("invalid constructor type") unless constructor[0] == :constructor
    constructor[2]
  end

  def method_hash(clazz)
    result = {}
    each_method_in(clazz) do |m|
      result[method_name(m)] = m
    end
    result
  end

  def method_name(method)
    raise RuntimeError.new("invalid method type") unless method[0] == :method
    method[1]
  end

  def method_params(method)
    raise RuntimeError.new("invalid method type") unless method[0] == :method
    method[2]
  end

  def method_param(method, i)
    method_params(method)[i]
  end

  def arity(method)
    method_params(method).size
  end

  def method_result(method)
    raise RuntimeError.new("invalid method type") unless method[0] == :method
    method[3]
  end

  def each_method_in(clazz, &block)
    if clazz[0] == :forall
      clazz = clazz[2]
    end
    raise RuntimeError.new("invalid object type") unless clazz[0] == :obj_type
    clazz[1..(clazz.size())].each(&block)
  end

end

