# Command line Interface

The project `libdyn.console` with the namespace `Dyn.Console` provides an interface for console interfaces to access the Dyn verification library.

# Components

`libdyn.console` contains two mayor components:

## Command Line Parser

This component parses user input in form of an array of strings `string[] args` and writes the values into an given object.

It supports the Utility Argument Syntax. TODO Link here

* short options `-s`
* short options chaining `-abc` is `-a`, `-b` and `-c`
* long options  `--long`
* parameters
  * in the following array cell: `-s p`,  `--long p`
  * seperated with special characters: `-s:p`,  `--long:p`, `-s=p`,  `--long=p`
  * directly following a short option: `-sp`
* arguments
* `--` enfoces arguments

* Number of parameters depend on number of method parameters

## Program.cs

This class combines most of the components in this project (except tests' and generators').

It
* handles command line input,
* tokenizes, parses optionally prints out abstract syntaax trees
* removes inheritance
* generates verification conditions with the weakesst precondition calculus
* infers types and bind unbound variables of the verifcation conditions
* converts it to _SMTLIB2_
* and calls an _SMTLIB_-solver

# Artefacts

* program code
* external documentation (*this document*)
* XML documentation (all public methods, classes)
* tests (coverage of 100% except `Program.cs` otherwise 94% line and 90% branch coverage)
