﻿using System;

namespace Dyn.Diagnostics
{

    /// <summary>
    /// Provides diagnostic information.
    /// </summary>
    public class DiagnosticEventArgs : EventArgs
    {
        private readonly DiagnosticInfo _info;

        /// <summary>
        /// Creates a <see cref="DiagnosticEventArgs"/> instance.
        /// </summary>
        /// <param name="info">The diagnostic </param>
        public DiagnosticEventArgs(DiagnosticInfo info)
        {
            Guard.EnsureNotNull("info", info);

            this._info = info;
        }

        /// <summary>
        /// Gets the diagnostic information associated with this event.
        /// </summary>
        public DiagnosticInfo Info { get { return this._info; } }
    }
}
