﻿using Dyn.Lexer;
using System;

namespace Dyn.Diagnostics
{
    public static class DiagnosticExtensions
    {
        public static void Invoke(this EventHandler<DiagnosticEventArgs> handler,
            object sender,
            DiagnosticInfo info)
        {
            Guard.EnsureNotNull("handler", handler);

            handler(sender, new DiagnosticEventArgs(info));
        }

        public static void Invoke(this EventHandler<DiagnosticEventArgs> handler,
            object sender,
            DiagnosticSeverity severity,
            Span span,
            string message)
        {
            Guard.EnsureNotNull("handler", handler);

            Invoke(handler, sender, new DiagnosticInfo(severity, span, message));
        }

        public static void Invoke(this IDiagnostic diagnostics,
            object sender,
            DiagnosticInfo info)
        {
            Guard.EnsureNotNull("diagnostics", diagnostics);

            diagnostics.DiagnosticInfoListener(sender, new DiagnosticEventArgs(info));
        }

        public static void Invoke(this IDiagnostic diagnostics,
            object sender,
            DiagnosticSeverity severity,
            Span span,
            string message)
        {
            Invoke(diagnostics, sender, new DiagnosticInfo(severity, span, message));
        }
    }
}
