﻿using System;

namespace Dyn.Diagnostics
{
    /// <summary>
    /// Represents a class or structure which processes diagnostic events.
    /// </summary>
    public interface IDiagnostic
    {
        /// <summary>
        /// Occurs when an see diagnostic event is raised.
        /// </summary>
        event EventHandler<DiagnosticEventArgs> DiagnosticInfo;

        /// <summary>
        /// The method that is compatible with <see cref="EventHandler{DiagnosticEventArgs}"/>.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="args">An object that contains the event data.</param>
        void DiagnosticInfoListener(object sender, DiagnosticEventArgs args);
    }
}
