﻿using System;
using System.Collections.Generic;

namespace Dyn.Parser
{
    public static class DynParserExtensions
    {
        public static IEnumerable<T> ParseAll<T>(this DynParser parser, Func<DynParser, T> func)
        {
            Guard.EnsureNotNull("parser", parser);
            Guard.EnsureNotNull("func", func);

            T result;

            while ((result = func(parser)) != null)
            {
                yield return result;
            }
        }
    }
}
