﻿using Dyn.Ast;

namespace Dyn.VerficationConditions
{
    public sealed class VerificationRequest
    {
        private readonly DynAssertionExpressionNode _expression;
        private readonly string _message;
        private readonly string _classname;

        public VerificationRequest(DynAssertionExpressionNode expression, string classname, string message)
        {
            Guard.EnsureNotNull("expression", expression);
            Guard.EnsureNotNull("message", message);
            Guard.EnsureNotNull("classname", classname);

            this._expression = expression;
            this._message = message;
            this._classname = classname;
        }

        public DynAssertionExpressionNode Expression { get { return this._expression; } }
        public string Message { get { return this._message; } }
        public string ClassName { get { return this._classname; } }
    }
}
