﻿using System.IO;
using System.Text;

namespace libdyn.generator.Ast
{
    internal static class Utilities
    {
        public static string Indent(string source, string prefix)
        {
            var builder = new StringBuilder();

            Indent(source, prefix, builder);

            return builder.ToString();
        }

        public static void Indent(string source, string prefix, StringBuilder builder)
        {
            using (var reader = new StringReader(source))
            {
                string line;

                while ((line = reader.ReadLine()) != null)
                {
                    builder.Append(prefix).AppendLine(line);
                }
            }
        }
    }
}
