﻿using Dyn.Console;
using System;
using System.Linq;
using Xunit;
using Dyn.Tests.Core.Diagnostics;
using Dyn.Diagnostics;

namespace Dyn.Tests.Console
{
    public static class ArgumentsUnitTests
    {
        [Fact]
        public static void Simple()
        {
            var args = new Arguments();

            IDiagnosticUnitTests.FuzzingEachSeverity(args, new Random(0));
            IDiagnosticUnitTests.FuzzingBatch(args, 1000, new Random(0));
            args.Invoke(null, IDiagnosticUnitTests.FuzzerDiagnosticInfo(new Random(0)));

            Assert.NotNull(args.Tokens);

            Assert.Equal(true, args.Interactive = true);
            Assert.Equal(string.Empty, args.SolverPath = string.Empty);
            Assert.Equal(true, args.ShowSummary = true);
            Assert.Equal(true, args.ShowColors = true);
            Assert.Equal(true, args.Verify = true);
            Assert.Equal(true, args.ShowConditions = true);
            Assert.Equal(true, args.ShowAst = true);
            Assert.Equal(true, args.ShowHelp = true);

            const string TEST_VALUE = "test.txt";
            Assert.NotNull(args.Files);
            Assert.Empty(args.Files);
            args.AddFile(TEST_VALUE);
            Assert.NotEmpty(args.Files);
            Assert.Equal(1, args.Files.Count);
            Assert.Equal(TEST_VALUE, args.Files.Single());
            Assert.True(args.Validate(System.IO.TextWriter.Null));
        }
    }
}
