﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using Dyn.Console.CommandLine;
using Xunit;

namespace Dyn.Tests.Console.CommandLine
{
    public static class CoverageUnitTests
    {
        [Fact]
        public static void Simple()
        {
            var inner = new NotImplementedException();

            Assert.NotNull(new OptionDefinitionException());
            Assert.NotNull(new ArgumentParserException());
            Assert.NotNull(new OptionDefinitionException(string.Empty));
            Assert.NotNull(new ArgumentParserException(string.Empty));

            var a = new OptionDefinitionException(string.Empty, inner);
            var b = new ArgumentParserException(string.Empty, inner);

            Assert.NotSame(a, b);
            using (var stream = new MemoryStream())
            {
                var formatter = new BinaryFormatter();
                formatter.Serialize(stream, a);
                formatter.Serialize(stream, b);
                stream.Position = 0;
                var b2 = formatter.Deserialize(stream);
                var a2 = formatter.Deserialize(stream);
                Assert.NotSame(a2, b2);
            }
        }
    }
}
