﻿using System;
using System.Reflection;
using Xunit;

namespace Dyn.Tests.Execution
{
    public struct Test
    {
        private readonly Action _action;
        private readonly MethodInfo _info;
        private readonly FactAttribute _attribute;
        private readonly string _hierarchy;

        public Test(
            Action action,
            MethodInfo info,
            FactAttribute attribute,
            string hierarchy)
        {
            Guard.EnsureNotNull("action", action);
            Guard.EnsureNotNull("info", info);
            Guard.EnsureNotNull("attribute", attribute);
            Guard.EnsureNotNull("hierarchy", hierarchy);

            this._action = action;
            this._info = info;
            this._attribute = attribute;
            this._hierarchy = hierarchy;
        }

        public Action Action { get { return this._action; } }
        public MethodInfo Method { get { return this._info; } }
        public FactAttribute Attribute { get { return this._attribute; } }
        public string Hierarchy { get { return this._hierarchy; } }
    }
}
