﻿using Dyn.Ast;
using Dyn.Parser;
using System;
using System.Collections.Generic;
using System.Linq;
using Xunit;

namespace tests.Parser
{
    public static class InheritanceUnitTests
    {
        private const string STD_LIB = "samples/valid/stdlib.dyn";

        public static Sample STD_LIB_SAMPLE =
            Sample.GetFiles(STD_LIB).Single();

        public static IEnumerable<DynProgramClassNode> STD_LIB_CLASSES =
           STD_LIB_SAMPLE.Tokenize().Simplify().ParseAll(true, p => p.ParseClass());

        [Theory]
        [MemberData("Valid", MemberType = typeof(SampleHelpers))]
        public static void SampleTests(Sample source)
        {
            var classes = new List<DynProgramClassNode>();

            // prevent adding std_lib twice
            if (!StringComparer.OrdinalIgnoreCase.Equals(STD_LIB_SAMPLE.ToString(), source.ToString()))
            {
                classes.AddRange(STD_LIB_CLASSES);
            }

            classes.AddRange(source.Tokenize().ParseAll(true, p => p.ParseClass()));

            InheritanceTransformer.Transform(Magic.ThrowOnError, classes);
        }
    }
}
