﻿using System.Collections.Generic;
using System.Linq;
using Xunit;

namespace tests
{
    public static class LineDiffUnitTests
    {
        private static void AssertDiffCount(int expected, IList<int> a, IList<int> b)
        {
            Assert.Equal(expected, LineDiff.Diff(a, b, EqualityComparer<int>.Default).Count());
        }

        [Fact]
        public static void Test()
        {
            int[] EMPTY = new int[] { };
            int[] _1_2 = Dyn.Utilities.AsArray(1, 2);
            int[] _1 = Dyn.Utilities.AsArray(1);
            int[] _2_3 = Dyn.Utilities.AsArray(2, 3);

            AssertDiffCount(0, EMPTY, EMPTY);
            AssertDiffCount(1, EMPTY, _1);
            AssertDiffCount(1, _1, EMPTY);
            AssertDiffCount(1, EMPTY, _1_2);
            AssertDiffCount(1, _1_2, EMPTY);
            AssertDiffCount(2, _1, _1_2);
            AssertDiffCount(2, _1_2, _1);
            AssertDiffCount(3, _2_3, _1_2);
            AssertDiffCount(3, _1_2, _2_3);

            Assert.Single(LineDiff.Diff(
                Dyn.Utilities.AsArray(1, 2, 3, 4, 5, 6, 7, 8, 9, 0),
                Dyn.Utilities.AsArray(1, 2, 3, 4, 5, 6, 7, 8, 9, 0),
                EqualityComparer<int>.Default));
            Assert.Equal(3, LineDiff.Diff(
                Dyn.Utilities.AsArray(1, 2, 3, 4, 5, 6, 7, 8, 9, 0),
                Dyn.Utilities.AsArray(1, 2, 3, 4, 5, 7, 8, 9, 0),
                EqualityComparer<int>.Default).Count());
            Assert.Equal(5, LineDiff.Diff(
                Dyn.Utilities.AsArray(1, 2, 3, 5, 6, 7, 8, 9, 0),
                Dyn.Utilities.AsArray(1, 2, 3, 4, 5, 6, 8, 9, 0),
                EqualityComparer<int>.Default).Count());
            Assert.Equal(3, LineDiff.Diff(
                Dyn.Utilities.AsArray(1, 2, 3, 4, 4, 4),
                Dyn.Utilities.AsArray(1, 2, 3, 0, 0, 0),
                EqualityComparer<int>.Default).Count());
        }
    }
}
