﻿using System.Collections.Generic;
using System.IO;
using Xunit;

namespace tests
{
    public sealed class Sample
    {
        private readonly string _path;

        private Sample(string path)
        {
            Assert.NotNull(path);
            this._path = path;
        }

        public StreamReader ToReader()
        {
            return File.OpenText(_path);
        }

        public static IEnumerable<Sample> GetFiles(string prefix)
        {
            Assert.NotNull(prefix);

            foreach (var file in Directory.GetFiles(".", prefix, SearchOption.AllDirectories))
            {
                yield return new Sample(file);
            }
        }

        public override string ToString()
        {
            return this._path;
        }
    }
}
